
'-----------------------------------------
'SAPI VOICE
'=========================================

  use com\ComUtil


  'from sapi.h


  'MIDL_INTERFACE("5EFF4AEF-8487-11D2-961C-00C04F8EE628")
  'ISpNotifySource : public IUnknown
  '
  extern virtual
  '
  '--------------------
  class ISpNotifySource
  '====================

    public

    extends IUnknown

        HRESULT SetNotifySink( 
            /* [in] */ __RPC__in_opt ISpNotifySink *pNotifySink)
        
        HRESULT SetNotifyWindowMessage( 
            /* [in] */ HWND hWnd,
            /* [in] */ UINT Msg,
            /* [in] */ WPARAM wParam,
            /* [in] */ LPARAM lParam)
        
        HRESULT SetNotifyCallbackFunction( 
            /* [in] */ SPNOTIFYCALLBACK *pfnCallback,
            /* [in] */ WPARAM wParam,
            /* [in] */ LPARAM lParam)
        
        HRESULT SetNotifyCallbackInterface( 
            /* [in] */ ISpNotifyCallback *pSpCallback,
            /* [in] */ WPARAM wParam,
            /* [in] */ LPARAM lParam)
        
        HRESULT SetNotifyWin32Event( void)
        
        HRESULT WaitForNotifyEvent( 
            /* [in] */ DWORD dwMilliseconds)
        
        HANDLE GetNotifyEventHandle( void)

  end class



  'MIDL_INTERFACE("BE7A9CCE-5F9E-11D2-960F-00C04F8EE628")
  'ISpEventSource : public ISpNotifySource
  '

  '-------------------
  class ISpEventSource
  '===================

    public

    extends ISpNotifySource

        HRESULT SetInterest( 
            /* [in] */ ULONGLONG ullEventInterest,
            /* [in] */ ULONGLONG ullQueuedInterest)
        
        HRESULT GetEvents( 
            /* [in] */ ULONG ulCount,
            /* [size_is][out] */ SPEVENT *pEventArray,
            /* [out] */ ULONG *pulFetched)
        
        HRESULT GetInfo( 
            /* [out] */ SPEVENTSOURCEINFO *pInfo)
        
  end class



    'MIDL_INTERFACE("6C44DF74-72B9-4992-A1EC-EF996E0422D4")
    'ISpVoice : public ISpEventSource
    '

    '-------------
    class ISpVoice
    '=============
    '
    public

    extends ISpEventSource

        HRESULT SetOutput( 
            /* [in] */ IUnknown *pUnkOutput,
            /* [in] */ BOOL fAllowFormatChanges)
        
        HRESULT GetOutputObjectToken( 
            /* [out] */ ISpObjectToken **ppObjectToken)
        
        HRESULT GetOutputStream( 
            /* [out] */ ISpStreamFormat **ppStream)
        
        HRESULT Pause( void)
        
        HRESULT Resume( void)
        
        HRESULT SetVoice( 
            /* [in] */ ISpObjectToken *pToken)
        
        HRESULT GetVoice( 
            /* [out] */ ISpObjectToken **ppToken)
        
        HRESULT Speak( 
            /* [string][in] */ 
            __in_opt  LPCWSTR pwcs,
            /* [in] */ DWORD dwFlags,
            /* [out] */ 
            __out_opt  ULONG *pulStreamNumber)

        HRESULT SpeakStream( 
            /* [in] */ IStream *pStream,
            /* [in] */ DWORD dwFlags,
            /* [out] */ 
            __out_opt  ULONG *pulStreamNumber)
        
        HRESULT GetStatus( 
            /* [out] */ SPVOICESTATUS *pStatus,
            /* [out] */ LPWSTR *ppszLastBookmark)
        
        HRESULT Skip( 
            /* [string][in] */ LPCWSTR pItemType,
            /* [in] */ long lNumItems,
            /* [out] */ ULONG *pulNumSkipped)
        
        HRESULT SetPriority( 
            /* [in] */ SPVPRIORITY ePriority)
        
        HRESULT GetPriority( 
            /* [out] */ SPVPRIORITY *pePriority)
        
        HRESULT SetAlertBoundary( 
            /* [in] */ SPEVENTENUM eBoundary)
        
        HRESULT GetAlertBoundary( 
            /* [out] */ SPEVENTENUM *peBoundary)
        
        HRESULT SetRate( 
            /* [in] */ long RateAdjust)
        
        HRESULT GetRate( 
            /* [out] */ long *pRateAdjust)
        HRESULT SetVolume( 
            /* [in] */ USHORT usVolume)
        
        HRESULT GetVolume( 
            /* [out] */ USHORT *pusVolume)
        
        HRESULT WaitUntilDone( 
            /* [in] */ ULONG msTimeout)
        
        HRESULT SetSyncSpeakTimeout( 
            /* [in] */ ULONG msTimeout)
        
        HRESULT GetSyncSpeakTimeout( 
            /* [out] */ ULONG *pmsTimeout)
        
        /* [local] */ HANDLE SpeakCompleteEvent( void)
        
        /* [local] */ HRESULT IsUISupported( 
            /* [in] */ LPCWSTR pszTypeOfUI,
            /* [in] */ void *pvExtraData,
            /* [in] */ ULONG cbExtraData,
            /* [out] */ BOOL *pfSupported)
        
        /* [local] */ HRESULT DisplayUI( 
            /* [in] */ HWND hwndParent,
            /* [in] */ LPCWSTR pszTitle,
            /* [in] */ LPCWSTR pszTypeOfUI,
            /* [in] */ void *pvExtraData,
            /* [in] */ ULONG cbExtraData)
        
    end class

    end extern


  '=================
  'UTILITY FUNCTIONS
  '=================

  sys Err

  '---------------------------------------------
  function ConnectVoice(ISpVoice** voice) as sys
  '=============================================
  dim as GUID          VoiceObjGuid, ISpVoiceGuid
  dim as HRESULT       hr
  dim as LPUNKNOWN     pUnkOuter
  '@pUnkouter=0
  guidval VoiceObjGuid, "96749377-3391-11D2-9EE3-00C04F797396"
  guidval ISpVoiceGuid, "6C44DF74-72B9-4992-A1EC-EF996E0422D4"
  err=CoCreateInstance VoiceObjGuid, pUnkouter, context, ISpVoiceGuid, byval @@voice
  if err then print "CoCreateInstance error code: " hex err
  return err
  end function

  '------------------------------------------------
  function DisconnectVoice(ISpVoice** voice) as sys
  '================================================
  if @voice then voice.Release
  @voice=0
  end function

  '
  'UTILITY MACROS FOR LOCAL USE
  '
  '
  '===========
  'VoiceMacros
  '===========
  def Connect
  {
     ISpVoice * %1
     Err=ConnectVoice %1
  }

  def Disconnect
  {
    Disconnectvoice %1
  }

  def Attach
  {
    @ %1.%2 = @ %2
  }

  def Detach
  {
    @ %1.%2 = 0
  }

  def ErrorHandler
  {
    if Err then
      print "SAPI Error " hex(Err)
      CoUninitialize
      return 0
    end if
  }

  def forever 0xffffffff

