/*
  ================
  CONSOLE ROUTINES
  ================

  18:03 07/10/2014 CP

  http://msdn.microsoft.com/en-us/library/ms686033(v=vs.85).aspx

  redirected i/o
  http://msdn.microsoft.com/en-us/library/windows/desktop/ms683457(v=vs.85).aspx

  OPTIONS
  =======
  % NoConsole
  % TryAttachConsole

  Console Modes:
  ==============
  
  001h Enable processed input
  002h Enable line input
  004h Enable input echo
  008h Enable window input
  040h Enable quick edit mode
  080h Enable extended flags
  020h Insert mode
  
*/

  
  type COORD
    short x,y
    =
    long c
  end type
  '
  type SMALL_RECT
   short left,top,right,bottom
  end type
  '
  type CONSOLE_SCREEN_BUFFER_INFO
    COORD      dwSize;
    COORD      dwCursorPosition;
    word       wAttributes;
    SMALL_RECT srWindow;
    COORD      dwMaximumWindowSize
  end type

  extern lib "KERNEL32.DLL"
  ! Sleep                      (sys msec)
  ! AttachConsole              (sys pp) as sys
  ! AllocConsole               () as sys
  ! FreeConsole                () as sys
  ! GetConsoleMode             (sys handle,*m)
  ! SetConsoleMode             (sys handle,m)
  ! GetConsoleWindow           () as sys
  ! GetStdHandle               (sys h) as sys
  ! SetConsoleCursorPosition   (sys h,coords)
  ! SetConsoleTextAttribute    (sys hOut,color)
  ! FillConsoleOutputCharacterA(sys hOut,ch,n,coords,long *writ)
  ! FillConsoleOutputAttribute (sys hOut,ab,n,coords,long *writ)
  ! GetConsoleScreenBufferInfo (sys hOut,CONSOLE_SCREEN_BUFFER_INFO*i)
  ! WriteConsole    alias "WriteConsoleA"    (sys hOut, lpBuffer, nNumberOfCharsToWrite, long *lpNumberOfCharsWritten, *lpReserved) as sys
  ! WriteFile       alias "WriteFile"        (sys hOut, lpBuffer, nNumberOfCharsToWrite, long *lpNumberOfCharsWritten, *lpOverlapped) as sys
  ! ReadConsole     alias "ReadConsoleA"     (sys hIn,lpBuffer, nNumberOfCharsToRead, long *lpNumberOfCharsRead, *lpInputControl) as sys
  ! ReadFile        alias "ReadFile"         (sys hIn,lpBuffer,nNumberOfCharsToRead, long *lpNumberOfCharsRead, *lpOverlapped) as sys
  ! GetCommandLine  alias "GetCommandLineA"  () as char*
  ! SetConsoleTitle alias "SetConsoleTitleA" (char*lpConsoleTitle) as sys
  ! ShellExecute alias "ShellExecuteA" lib "Shell32.dll" _
    (sys Hwnd, char* operation,file,parameters,directory,sys ShowCmd) as sys
  end extern

  % STD_INPUT_HANDLE  -10
  % STD_OUTPUT_HANDLE -11
  % STD_ERROR_HANDLE  -12 

  sys ConsOut,ConsIn,ConsErr,ConsoleAttached

  ConsIn  = GetStdHandle STD_INPUT_HANDLE
  ConsOut = GetStdHandle STD_OUTPUT_HANDLE

  #ifndef NoConsole
    #ifdef TryAttachConsole
      if ConsOut then
        AttachConsole -1 'attach to console of parent process
        ConsoleAttached=1
      else
        AllocConsole
        ConsOut = GetStdHandle STD_OUTPUT_HANDLE
        ConsIn  = GetStdHandle STD_INPUT_HANDLE
        ConsoleAttached=0
      end if
    #else
      AllocConsole
      ConsIn  = GetStdHandle STD_INPUT_HANDLE
      ConsOut = GetStdHandle STD_OUTPUT_HANDLE
    #endif
    '
    SetConsoleTitle "OxygenBasic"

  #endif 'no sNoConsole


  def Color   SetConsoleTextAttribute ConsOut,
  def Wait    Getkey
  def WaitKey GetKey
  def Pause   Getkey
  'print override
  def print   output
  def printl  output cr

  function SetPos(sys x,y)
  ========================
  COORD c={x,y}
  SetConsoleCursorPosition  ConsOut,c.c
  end function


  function cls()
  ==============
  sys   hConsole      = ConsOut
  COORD coordScreen   = { 0, 0 } 'home for the cursor 
  sys   dwConSize
  sys   cCharsWritten
  CONSOLE_SCREEN_BUFFER_INFO csbi
  '
  'Get the number of character cells in the current buffer. 
  if not GetConsoleScreenBufferInfo( hConsole, csbi ) then return
  '
  dwConSize = csbi.dwSize.X * csbi.dwSize.Y;
  '
  'Fill the entire screen with blanks.
  if not FillConsoleOutputCharacterA( hConsole,32,dwConSize,coordScreen.c,cCharsWritten) then return
  '
  'Get the current text attribute.
  if not GetConsoleScreenBufferInfo( hConsole, csbi ) then return
  '
  'Set the buffer's attributes accordingly.
  if not FillConsoleOutputAttribute( hConsole,csbi.wAttributes,dwConSize,coordScreen.c,cCharsWritten ) then return
  '
  'Put the cursor at its home coordinates.
  SetConsoleCursorPosition( hConsole, coordScreen.c )
  end function



  Function output(string bufout)
  ==============================
  static long buflen,bufrit
  buflen=len bufout
  WriteFile ConsOut,strptr bufout,buflen,bufrit,null
  End Function


  Function input() As string
  ==========================
  static long blen      
  static zstring bufin[0x1000]      
  ReadFile ConsIn,strptr bufin,0xfff,blen,null
  return left bufin,blen
  End Function


  Function GetKey(sys w=0) as sys
  ===============================
  static long blen,mode
  static zstring z[4]
  GetConsoleMode ConsIn,mode
  SetConsoleMode ConsIn,0
  ReadConsole ConsIn,strptr z,1,blen,null
  SetConsoleMode ConsIn,mode
  return ?z
  End Function


  string tab,cr,qu
  tab=chr 9
  qu=chr 34
  cr=chr(13,10)


