/*
  typedef struct _WIN32_FIND_DATA {
  DWORD    dwFileAttributes;
  FILETIME ftCreationTime;
  FILETIME ftLastAccessTime;
  FILETIME ftLastWriteTime;
  DWORD    nFileSizeHigh;
  DWORD    nFileSizeLow;
  DWORD    dwReserved0;
  DWORD    dwReserved1;
  TCHAR    cFileName[MAX_PATH];
  TCHAR    cAlternateFileName[14];
  } WIN32_FIND_DATA, *PWIN32_FIND_DATA, *LPWIN32_FIND_DATA;
*/

'https://msdn.microsoft.com/en-us/library/windows/desktop/gg258117(v=vs.85).aspx
'selected File Attribute Constants
% FILE_ATTRIBUTE_ARCHIVE          0x20
% FILE_ATTRIBUTE_DEVICE           0x40
% FILE_ATTRIBUTE_DIRECTORY        0x10
% FILE_ATTRIBUTE_HIDDEN           0x2
% FILE_ATTRIBUTE_NORMAL           0x80
% FILE_ATTRIBUTE_READONLY         0x1
% FILE_ATTRIBUTE_SYSTEM           0x4
% FILE_ATTRIBUTE_TEMPORARY        0x100


  function GetFileList(string filter, sys*count,optional dirq) as string
  ======================================================================
  '
' sys xyz
  '
  macro appendList(s,w,i,  ls,lw) '(string *s,w, sys *i)
    sys ls=len s
    sys lw=len w
    if i+lw>ls
      s+=nuls 1024 '+lw
    end if
    mid s,i+1,w
    i+=lw
  end macro 
  '
  WIN32_FIND_DATA f
  sys    a,e,h,fi
  string flist
  string cr=chr(13,10)
  '
  h=FindFirstFile filter, @f
  count=0
  if h then
    do
      a=0
      if f.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY
        if dirq then a=1
        if asc(f.cFileName)=46 then  a=0 '.' ' ..'
      else 'NOT A DIRECTORY
        if not dirq then a=1
      end if
      if a then
        count++
        appendlist flist, f.cFileName+cr, fi
      end if
      e=FindNextFile h, @f
      if e=0 then
        e=GetLastError() 'should be 18 when no more files
        exit do
      end if
    end do
    FindClose h
  end if
  return left (flist,fi)
  '
  end function


  function ExtractDirName(string s) as string
  ===========================================
  sys i,le
  le=len s
  byte *b=le+strptr s
  for i=le to 1 step -1
     @b--
     if b=47 or b=92
       return left s,i-1
     end if
  next
  return s
  end function


  function ExtractFileName(string s) as string
  ============================================
  sys i,le
  le=len s
  byte *b=le+strptr s
  for i=le to 1 step -1
     @b--
     if b=47 or b=92
       return mid s,i+1
     end if
  next
  return s
  end function


  function ExtractDotName(string s) as string
  ===========================================
  sys i=len s
  do
    if i<1 then return ""
    if asc(s,i)=46 then return mid(s,i)
    i--
  end do
  end function


  function RtrimDotName(string s) as string
  =========================================
  sys i=len s
  do
    if i<1 then return s
    if asc(s,i)=46 then return left(s,i-1)
    i--
  end do
  end function


  function ParseFileName(string src, sys *ii, string *mnm, *xnm) as string
  ========================================================================
  sys    i=1, dt
  string s
  s=unquote getword src,ii

  skipspace(src,ii)
  if s="" then return ""
  '
  do
    i++
    select asc s,i
    case 46        : dt=i 'position of latest dot
    case 47,92     : dt=0 'exclude .\ ..\
    case 0         : exit do
    end select
  end do
  '
  if dt then
    mnm=left s,dt-1
    xnm=mid s,dt
  else
    mnm=left(s,i-1)
  end if
  return mnm+xnm
  end function


  function ExeDir() as string
  ===========================
  char s[256]
  byte b at strptr s
  GetModuleFileName 0,s,256
  sys i
  do
    select b
    case 0  : exit do
    case 92 : i=@b
    end select
    @b++
  end do
  return left s,i-strptr s
  end function


  function CurDir() as string
  ===========================
  char s[256]
  GetCurrentDirectory 256, s
  return s
  end function


