
  ======================
  macro CreateMemoryPool
  ======================

  'holds up to 512 strings of lengths 0..120 bytes
  '
  'each string: long n + n data bytes + min 4 null bytes
  '             returning pointer to the data bytes

  Function InstallMemoryPool(sys mode) as sys
  ===========================================

  indexbase 1    'for arrays

  static sys newmemo    'original
  static sys freememo   'original
  static long i         'index for recycler stack
  static long e         'next place in the pool memory
  static long p[512]    'recycler stack
  static byte m[0xf008] 'string space
                        'including null zone for empty strings

  'INNER
  function NewMem(sys pd, n) as sys, label
  ========================================
  sys a,f,j,qb
  select n
  case 0
    return @m+0xf004 'NULL ZONE
  case 1 to 120
    if i
      a=p[i]   'RECYCLE
      i--      'POP STACK
      f=1
    elseif e<0xf000
      a=e      'NEW UNUSED MEM
      e+=0x80
      f=1
    end if
    if f
      a+=@m      'ADD MEM BASE
      (long) *a=n
      if pd
        qb=a+4
        for j=1 to n step 4
          (long) *qb = (long) *pd 'COPY DWORDS
          qb+=4
          pd+=4  
        next
      end if
      return a+4  'OFFSET LENGTH FIELD
    end if 'f
  end select
  return call newmemo pd,n 'STRINGS NOT USING POOL
  end function

  'INNER
  function FreeMem(sys q) as sys, label
  =====================================
  long n
  sys  j,qb,qe
  q -= 4 'POINT TO LENGTH
  qb=q-@m
  if qb>=0 and qb<0xf008 'POOL ADDRESS RANGE CHECK
    n = (long) *q
    if n = 0 then return 0 'EMPTY STRING
    i++
    p[i] = qb 'ADD TO RECYCLER STACK
    qe = q+n-1+sizeof sys
    for j = q to qe step sizeof sys
      *j = 0 'WIPE MEM
    next
    return 1
  end if
  return call freememo q+4 'STRINGS OUTSIDE THE POOL  
  end function
  
  def SysAllo [ebx+160]
  def SysFree [ebx+168]

  if mode=1
    sys a
    a=[ebx] 'POINTER TO PSYSFUNS
    if a
      *a=ebx  'SET PSYSFUNS TO BASE OF FUN TABLE (BSS) (runt.o2bas)
    end if
    'setup memory allocation intercept
    newmemo  = SysAllo   'SAVE ORIGINAL SysAllocByteStringLen
    freememo = SysFree   'SAVE ORIGINAL SysFreeString
    SysAllo  = @NewMem   'INTERCEPT
    SysFree  = @FreeMem  'INTERCEPT
  elseif mode=0
    'disconnect
    SysAllo = newmemo   'RESTORE ORIGINAL
    SysFree = freememo  'RESTORE ORIGINAL
  elseif mode =-1
    'MUST NOT USE STRINGS IN THE LIVE PROCEDURE
    'print hex ([ebx+160]) "  " hex([ebx+168])
    'print hex (@NewMem) "  " hex(@FreeMem)
  end if
  end function 'InstallPool

  end macro

  'extern
  CreateMemoryPool
  InstallMemoryPool 2 'INSTALL
  'end extern


/*
  'extern

  CreateMemoryPool
  InstallMemoryPool 1 'INSTALL
  string s="world"
  print s
  print "hello " s
  InstallMemoryPool 0 'UNINSTALL
  print "ok"

  'end extern
*/