


  '        ##
  '       ####
  '      ######
  '     ########
  '    ##########
  '   ############
  '  ##############
  ' ################
  'GLOBAL DEFINITIONS
  '==================

  indexbase 0

  'GLOBAL DATA TYPES
  '=================

  type hashref
    int h   ' hash code
    int l   ' linked list index (fwds only)
    int b   ' brc nesting level
    int n   ' namespace code
  end type

  type preced
    int pr
    int sw
    int le
  end type

  type stack
    int a
    int b
    int c
    int d
    int e
    int f
    int g
    int h
    int i
    int j
    int k
    int l
  end type

  type nester
    int me
    int aoffl
    int aoffs
    int asce
    int lclv
    int spe
    int ixb
    int sr2
    int ct2 
    int tys
  end type


  'GENERAL CONSTANTS
  '=================

  const int    htyp=512       'HIGHER TYPES BASE

  const string she=chr(248)   '#show DELIMITER
  const string dfd=chr(249)   'DATA FIELD DELIMITER
  const int    iq4=250        'INTERNAL QUOTE CODE
  const string iq=chr(iq4)    'INTERNAL QUOTE MARK
  const int    lnm=251        'ORIGINAL LINE MARKER (IN COMMENT)
  const int    hasa=124       ' | HIGH ASSEMBLER INSTRUCTION CODE
 'const string hasm=chr(hasa) 'HIGH ASSEMBLER INSTRUCTION MARLER
  const string sq=chr(252)    'TRANSFER MARKER START
  const string eq=chr(253)    'TRANSFER MARKER END
  const string declar=chr(254)'LAZY DECLARATION
  '
  const string endex=" as at then else elseif end to step if do for when while "
  '
  const string htb=chr(9)     'HORIZONTAL TAB
  const string crg=cr+";"+cr  'END OF LINE FOLLOWED BY BLANK COMMENT
  const string qu=chr(34)     'DOUBLE QUOTE MARK
  const string cm=chr(44)     'COMMA
  const string sp=cr+"("+cr   'START OF BLOCK
  const string ep=cr+")"+cr   'END OF BLOCK
  const string stp=" : "      'NORMAL STATEMENT SEPARATOR
  const string sep =" "       'SINGLE SPACE

  const string exdo="jmp long _do"+cr+"._end_do"+ep      'ENDDO
  const string exnx="jmp long _for"+cr+"._end_for"+ep    'NEXT
  const string exsl="._end_cas"+cr+"._end_sel"+ep        'ENDSEL
  const string exei="jmp fwd _end_if"+cr+"._end_cnd"+cr  'ELSEIF
  const string exel="jmp fwd _end_if"+cr+"._end_cnd"+cr  'ELSE
  const string exif="._end_cnd"+cr+"._end_if"+ep         'ENDIF
  const string exitdo=cr+"exit do"+cr+"end if"+cr        'COND EXIT
  const string contdo=cr+"continue do"+cr+"end if"+cr    'COND CONTINUE

  'META TYPES
  '==========

  const  string metatypes="
  >0   compund variable,
   0   primitive variable or constant,
  -1   (unused),
  -2   (unused),
  -3   type / class,
  -4   low level function,
  -5   proc / sub / function / method,
  -6   (unused),
  -7   (unused),
  -8   struct from typedef,
  -9   reserved word,
  -10  x86 register,
  -11  attributes,
  -12  namespace,
  -13  o2 major keyword,
  -14  o2h major keyword,
  -15  primitive type,
  -16  core functions,
  -17  core float macro,
  -18  low level macro / equate,
  -19  core macro,
  -20  high level macro,
  -21  internal code macro,
  -30  label,
  -31  literal number,
  -32  literal string,
  -33  enum enumeration,
  "

  'also numeric equates


  'OP CODING TO JUMP INSTRUCTION = <> > >= <= <

  'must conserve right hand space
  const string jmpname="
  12 jb 
  13 jae 
  14 jz 
  15 jnz 
  16 jbe 
  17 ja 
  1C jl 
  1D jge 
  1E jle 
  1F jg 
  92 jae 
  93 jb 
  94 jnz 
  95 jz 
  96 ja 
  97 jbe 
  9C jge 
  9D jl 
  9E jg 
  9F jle 
  "

  const string cops=_
  "       jb  jae jz  jnz jbe ja                  jl  jge jle jg  "
  '       2   3   4   5   6   7                   C   D   E   F   '  
  '       8   12  16  20  24  28                  48  52  56  60  '


  'OPERATORS
  '=========
  '
  'this list is used to return an opnumber from an opname (identops)
  'these opnumbers are all hardcoded
  'must conserve right hand space char
  const as string opname="
  0 load 
  1 load 
  2 = 
  3 cmp 
  4 push 
  5 dump 
  6 pop 
  7 neg 
  8 += 
  9 -= 
  10 swap 
  11 not 
  11 ! 
  12 inc 
  13 dec 
  14 *= 
  15 /= 
  20 == 
  21 <> 
  28 < 
  29 >= 
  30 <= 
  31 > 
  32 boolean 
  33 and 
  33 & 
  34 or 
  34 | 
  35 xor 
  65 and= 
  66 or= 
  67 xor= 
  42 * 
  43 + 
  45 - 
  47 / 
  92 \ 
  71 && 
  72 || 
  73 ^^ 
  74 << 
  75 >> 
  94 ^ 
  "

  'DATA TYPES
  '==========
  '
  'BASE DATA TYPES
  '===============

  'also used for reverse dictionary to obtain type name from type code

  const string idtype="
  void 0,
  sbyte 1,
  short 2,
  long 4,
  sys 8,
  byte 21,
  ubyte 21,
  word 22,
  dword 24,
  quad 48,
  single 64,
  double 68,
  extended 6A,
  fpu 40,
  char A1,
  wchar A2,
  zstring A1,
  zstring2 A2,
  bstring C1,
  bstring2 C2,
  string E1,
  wstring E2,
  "

  '
  'CALLING CONVENTIONS
  '===================
  '
  const string callco="
  stdcall 100"_
  cdecl 101"_
  ms64 102"_
  ox64 103"_
  pascal 108"_
  "
  '
  'ox64 103 internal use






  'FLOATING POINT MACROS
  '====================

  const string exponents=
  |sp -16 : fstcw [esp] : fstcw [esp+2] : or [esp],0xc00 : fldcw [esp]
  fldl2e : fmulp st1 : fld st0 : frndint : fsub st1,st0
  fxch : f2xm1 : fld1 : faddp st1 : fscale : fstp st1
  fldcw [esp+2] : |sp 16"
  "

  const string powers="
  |sp -16 : fstcw [esp] : fstcw [esp+2] : or [esp],0xc00 : fldcw [esp] : ( :
  fist dword [esp+8] : and byte [esp+8],1 : jnz exit : fxch : fabs : fyl2x : fld st0
  frndint : fsub st1,st0 : fxch : f2xm1 : fld1 : faddp st1,st0 : fscale : fstp st1 : jmp fwd nng
  ) : fxch : fst dword [esp+8] : fabs : fyl2x : fld st0 : frndint : fsub st1,st0 : fxch
  f2xm1 : fld1 : faddp st1,st0 : fscale : fstp st1 : ( : and byte [esp+11],128 : jz exit : fchs : )
  .nng : fldcw [esp+2] : |sp 16
   "



  '========
  'CAPACITY
  '========

  '
  const int maxit=99999  'size of entity array
  const int smaco=12      'elements in maco(0..7) macs(0..3)
  const int omacs=smaco-4 'offset to maco string pointers (entity strings)

  macro macio(x,y) maco[(x)*smaco+b]


  '======
  'ARRAYS
  '======


  'COMPILER BUFFERS
  '
  ========================================================
  '
  string  dbuf[511] 'BUFFERS FOR COMPILE CODE
  int     lbuf      'LENGTH OF SELECTED BUFFER
  int     ibuf      'INDEX FOR SELECTED BUFFER
  sys     pbuf      'POINTER TO SELECTED BUFFER
  '
  'ENTITY STORAGE
  '
  ========================================================
  % opdw 10
  int     opd[1000*10-1], ope ' Assembly code data
  string  opn[999],ops[999]   ' Assembly code data
  '-------------------------------------------------------------------
  int     maco[maxit*smaco-1] ' buffer for all definitions
  hashref mach[maxit]         ' hashes
  int     macb[2047]          'hash base links
  ========================================================
  '
  '
  'GENERAL

  ========================================================
  int    prc[127,1]    ' precedence buffer 0=op 1= pr level
  int    ctb[99]       ' control block type
  int    hei[99]       ' control block elseif suppressor flag
  stack  st[99]        ' general nesting stack
  stack  stk           ' general nesting stack
  int    jn            ' string join flag
  int    sta[99]       ' precedence stack
  int    slc[99]       ' `select` stack cas
  int    slt[99]       ' `select` stack cas type
  int    sle[99]       ' `select` stack enumeration
  string sls[99]       ' `select` stack expression (for switch)
  preced pre[99]       ' operator precedence
  string nes[99]       ' nested names
  string nxs[99]       ' nested next step
  --------------------------------------------------------
  string por[99]       ' param original word (ow)
  string paw[99]       ' param wg word
  string pas[99]       ' parameter expression
  int    pao[99]       ' param last operator
  int    pat[99]       ' param type
  int    pst[99]       ' param stack size allocated
  string pav[99]       ' param conversion code
  string pax[99]       ' param indirect addr code
  --------------------------------------------------------
  int    libu[511]     ' library use flag
  int    libo[511]     ' library offset list
  string libs[511]     ' library name list
  string libl[511]     ' library used proc list
  --------------------------------------------------------
  string wva[15]       ' var / dim statements
  nester scop[99]      ' nesting scope index
  ========================================================
  string sregs[100]    ' nesting indexers
  string wp[63]        ' macro params
  string ebd[255]      ' embedded data
  ========================================================
  int    sti[53]       ' index to file name log ssn
  string ssf[63]       ' include file path name
  string sst[63]       ' include (preserve parent text)
  string stb[63]       ' include (preserve included text)
  string ssn[999]      ' include file name log
  int    ssh[999]      ' include content hash log
  string rgp[15]       ' register param macros (for 64 bit fast calls)
  string regn[15)      ' register param names (for 64 bit fast calls)
  int    typl[15)      ' local param type
  long   cbrk[63),cbri ' block nests {}
  ========================================================
  'PROCEDURE STATE
  'funi   in function flag
  'atf    external flag
  'lcl    local variables used flag
  'lcls   local strings used flag
  'blcl   patch position for stack (ebp) instruction
  'plcl   patch position for stack allocation
  'mlcl   stack space requirement
  'reto   function param boundary
  'retb   function param base
  'ccp    calling convention
  'mqf    function record index
  'typp   return type code
  'noin   no initialise var flag
  'funn   function type 11 12 13
  'dts    temp strings used flag
  'dcs    concatenation buffer used
  'funl   patch position for offset of proclist record (link)
  'flbl   prevent deletion during compaction flag
  'funm   original or alias name (no case conversion)
  'fnam   function name
  'fsig   function signature
  '
  int    funi,atf,lcl,lcls,blcl,plcl,mlcl
  int    reto,retb,ccp,mqf
  int    typp,noin,funn,dts,dcs
  int    funl,flbl
  string funm,fnam,fsig
  ========================================================
  'TYPE/UNION FLAGS
  int    unif[7],unio[7],unim[7]
  string unin[7]
  ========================================================
  sys    sysfuns[1023]' runtime fun table
  string mdl_path     ' 
  ========================================================
  string expwn[999]    ' export labels
  string expal[999]    ' export dll symbols
  int    expi[999]     ' export index for sorting
  ========================================================
  int    dima[16],dimi ' array const offset
  ========================================================
  string wtn[32]       ' temp expressions
  int    tmpi          ' serialiser for temp vars
  ========================================================





'SIMPLE GLOBAL VARIABLE DESCRIPTIONS
'===================================

'  fq      include file index
'  me      macro list end boundary
'  mp      entity index
'  mq      linked entity index
'  mc,md  sem codes
'  mct     macro anti recursion counter
'  mex     macro anti recursion source buffer limit
'  swd     start of current word
'  nwd     start of next word
'  ewd     space count at end of word
'  dtf     dot flag for dotted words
'  dcf     double colon flag for :: namespace words
'  aoff    aoffl,aoffs' offsets for indexers
'  asce    ascel,asces ' offset ascend/descend flag
'  regs    regsl,regss regst' indexers
'  woff    offset of element
'  voff    offset of variable
'  toff    offset of vf table
'  pw      pw procedure word
'  bgl     beginning of current line
'  lct     line count
'  incli ' prevent %params from being substituted in next macro
'  mcf macro param insertion flags
'  nan     not a number flag
'  lmax    macro hash buckets max links
'  ascw    ascii of word
'  ascn    ascii of next word
'  ascy    ascii of symbol
'  elsize variable size from last element
'  varf    variable func mode
'  sigf    signature enable flag
'  sig     signature of func
'  sigu    default member assignments
'  sigv    default function param assignments
'  sog     signature of element/return
'  ou      original indirection prefixes
'  ow      original word
'  owa     original word array
'  vew     compile mode: 0 normal 2 include source with errors in o2 script (runtime)
'  noop    no operators flag
'  typ     type of word: primitives and higher types
'  typm    main type; of expression
'  tye     type of element
'  mtyp    metatype
'  phr     conditional lhv rhv
'  cpa     comparator flag
'  leni    length of last insertion
'  inpi    forward insertion point
'  clon    clone flag (getas)
'  noo     new flag (getas)
'  lent    length of object (identype)
'  lenw    length of word (word)
'  op      operator coding
'  oq      last operator code (set by wrd)
'  ind     indirection
'  wi      with flag
'  j       output index
'  pt      any pointer
'  nst     nesting index
'  nx     `next` stack index
'  slx    `select` stack index
'  rga     cpu accum select
'' nquod   inhibit string literal referencing flag
'  qot      quote flag
' nmb       number flag
'---------------------------------------------
'  wu      global word string
'  wu1     global word string
'  wu2     global word string
'  t       output string
'  wpfx    pointer/array code to insert before vars (assembler)
'  epfx    pre expressions to resolve before main expression
'  ppfx    post expressions to resolve after series of expressions
'  cpfx    pointer/array code to insert before vars (emitter)
'  wth     `with` assignment prefix
'  asg     assignment string to append / post append to expression
'  asi     assigner/eqator flag
'  wg      last wr pword
'  opg     last op in expression
'  typg    assignment type
'  tys     specified default type
'  cnc     conditional code
'  cnd     conditional flag
'  tmpst   tmp storage offset
'  tmpstk  tmp storage offset use in 64 bit mode when param is pushed
'  fpu     fpu directive flag
'  pc      param stack index
'  cco     calling convention
'  coco    member derived calling convention for encodele
'  vwb     selected view start
'  vwe     selected view end
'  uk      call compatibility mode
'  libe    library list boundary
'  libr    library name for declared imports
'  impo    import block flag
'   mth    sub/function/method flag
'   priv   private flag
'   brc    scope nesting index
'------------------------------------------------
'  da      value accumulator
'  dv      value register (64 bit float)
'  qv      value register (64 bit integer)
'------------------------------------------------
'  asgm    multiple assignment flag
'  asgb    bracket used to encapsulate
'  asgo    offset
'  asgi    stride
'  asgj    structure array stride
'  asgk    structure string offset
'  asgl    local/global string flag
'  asgn    structure element offset
'  asgs    structure string
'------------------------------------------------
' opns     name of operations
' opnsl    operations name list
' lbw      last label
' ipath    includepath
' lpath    librarypath
' nprec    no precedence flag
' nrs      not resolved flag
' dep      dependent code flag
' cnst     constantflag (Const like Dim)
' ovr      inheritance override flag
' ixb      index base
' bref     byref flag
' ths      implicit this flag
' cef      C output flag
' cefi     C word output flag
' cbi      C output buffer index
' pef      pe format flag 1=dll 2=exe
' pem      pe mode flag 64=64 bit mode
' pexn     pe file name
' cexn     C output file name
' cbuf     C output buffer
' pdr      in procedure flag
' pps      popstack flag
' tmnt     terminate flag
' dlb      dll list base
'' dlbf    dll list base late binding flag
' omo      oxygen io string mode
' rexi     64 bit mode register flag
' expf     export section flag
' rsrf     resource section flag
' indt     indirection of type
' lclv     local variables flag
' ary      TYPE array descriptor accum string
' arf      array resolutiln flag  
' extn     extern flag, C
' sps      string pool buffer string
' spe      string pool end index
' spl      string pool buffer length
' hlo      header language output
' cpuw     cpu width 32/64
' spw1     stack pointer width
' spw2     stack pointer width x 2
' pesp     [esp] or [rsp]
' casf     case mode flag
' dvl      member spec incl signature
' dvm      default values retrieved from signature
' mesb     state intrinsic base index for declarations, dims etc
' mest     state local base index for declarations, dims etc
' vaf      carrier for varf (procedures() callcoc()
' vstp     force variable location step increment
' pres     string buffer 'preserve' flag
' num      generic number format spec
' cas      case flag
' nth      that' flag suppresses 'this'
' oxypath  oxygen path list
' hostdll  oxygen path resolver macro
' bvg      byval flag in expressions for procedures
' uniq     unique flag to prevent duplicate definitions (at same nesting level)
' ispr     expression contains string procedure. flag
' typk     cast type
' dats     initialised data block
' datc     initialised data block item counter
' dati     initialised data block boundary
' lnkc     code side data link table
' lnkd     data side data link table
' nsto     prevent data being added to data section
' stkb     stacked bytes - parameters
' dts      delete temp strings flag
' dls      delete local strings flag
' stp      separator string
' parx     parameter expression flag
' divi     division operator flag (detect in precedence)
' defbuf   buffer for stray #defines
' dwl      lower dword
' dwu      upper dword
' met      metaval flag
' nl       new line flag
' lnmks    last line number encounteres
' pakd     no padding flag for types and classes
' ccx      calling convention code
' wbse     base operand [ebx+5004] etc prior to pointering
' casg     flag to treat '=' as assign in conditionals
' nobr     flag preventing array interpration (bracket)
' ebdi     embedded data string index
' nmac     flag preventing macro expansion
' nstod    flag inhibiting storage of literal data
' cboolf   bool condition flag
' boolcnd  macro to set z flag
' boolify  macro to set qeax 0 / -1
' osg      preassign name (ow)
' psg      preassign string
' wsg      preassign operand
'proclist  list of procedures and their locations
'plistend  end of list
'pls       proclist position (hex string)
'plp       proclist position
'plq       data record patch position
'calllist  list of declarations
'clistend  end of list
'declist   list of declarations
'dlistend  end of list
'compact   dead code removal flag
'tranpass  translator pass
'abst      abstract assembler output
'depsp     dependency space (allocated for run-time compiling)
'gsrc      global source
'gsco      global output (ascii text) code
'cfile     current file (included files)
'preproc   preprocessor switch
'asxp      assignment expression flag
'elct      element count
'elsz      element size
'ctal      conditional compare tally
'aml       member array size
'vtq       member virtual modality
'cpoint    #cpointer mode flag
'opers    operations list
'nsi      namespace index
'nsp      namespace query index
'nsq      namespace query index
'nsw      namespace name
'rps      reprocess statements flag
'hiex     higher expression code for reprocessing
'tyd      typedef flag (excluding typedef struct)
'cpu quad convert fpu quad to cpu quad
'cnsl  console mode flag for PE file SubSytem 3 (normally 2)
'eord  export ordinal counter
'noco  flag to include commas in capts()
' sigs  parameters type signature
' sigd  parameters indirection signature
'===================================================================



'----------------------
'SIMPLE GLOBAL VARIABLES
'======================


  int mc,md,me,mp,mq,mct,mex,swd,nwd,ewd,dtf,dcf,aoff,aoffl,aoffs,asce,ascel,asces
  int woff,voff,toff,lct,incli,mcf,nan,lmax,ascw,ascn,ascy,elsize,varf,vaf,sigf,fq,fql
  int noop,abst,typ,tye,typm,mtyp,phr,cpa,leni,inpi,clon,noo,lent,lenw,bgl
  int op,oq,ind,wi,j,opg,typg,tys,asi,nst,nx,slx,rga,nmb,qot
  int lbr=40,rbr=41,iq1=34,iq2=96,iq3=96,ct1=39,ct2=59,sr1=58,sr2=58
  int prec,prl,nsl,ipe,cnc,cnd,tmpst,tmpstk,fpu,pc,cco,coco,aml,vtq
  int vwb,vwe,uk,libe,impo,mth,priv,brc,dep,pps
  int asgb,asgo,asgi,asgj,asgk,asgl,asgm,asgn,nprec,nrs,cnst
  int ovr,ixb,bref,ths,cbi,cef,cefi,pef,pem,pdr,tmnt,dlb
  int rexi,expf,rsrf,indt,lclv,extn,spe,spl,hlo
  int cpuw,casf,mesb,mest,vstp
  int nodel,cas,nth,bvg,uniq,ispr,typk,datc,dati
  int nsto,stkb,parx,divi,met,nl,pakd,arf,ccx,casg
  int nobr,ebdi,nmac,nstod,cboolf,convs,plistend,clistend,dlistend,plp,plq
  int compact,tranpass,depsp,preproc,asxp,elct,elsz,ctal,cpoint
  int nsi,nsp,nsq,rps,tyd,hix,independent,cnsl,eord,noco


  quad qv
  double da,dv
  int pt


  string t,wu,wu1,wu2,ou,ow,owa,regs,regsl,regss,regst,cpua,pw,sig,sigu,sigv,sog,opns,opnsl
  string wpfx,epfx,ppfx,wth,asg,asgs,wg,lbw,ipath,lpath,libr,ary,sps,dvl,dvm
  string qeax,qecx,qedx,qebx,qesp,qebp,qesi,qedi,peax,pecx,pesp,pedi,pesi,ledi,medi
  string pusheax,popeax,spw1,spw2,pexn,cexn,cbuf,cpfx
  string oxypath, hostdll,dats,lnkc,lnkd,defbuf,lnmks,wbse,osg,psg,wsg
  string boolcnd,boolify,reloadaddr,gsrc,gsco
  string savestack,restorestack,preserveregs,restoreregs
  string pls,proclist,calllist,declist
  string RootDir,cfile,opers,nsw,hiex,cpuquad,fpuquad,sigs,sigd

sub GlobalClear()
=================
  '
  int a
  '
  ert=0
  ers=""
  cpa=0
  parx=0
  brc=0
  asce=1
  lclv=0
  wth=""
  wi=0
  ths=0
  prec=0
  phr=0
  ipe=0
  nsl=0
  fq=0
  fql=1
  dv=0
  asi=0
  cnd=0
  lbw=""
  pef=0
  pem=0
  nst=0
  pdr=0
  bref=1 'default byref
  tmnt=0
  libe=1
  dlb=1
  expf=0
  rsrf=0
  nrs=0
  funi=0
  libr=""
  extn=0
  cas=0
  casf=0
  cnst=0
  cbri=0
  uniq=0
  cpuw=4
  ispr=0
  tys=0
  typk=0
  datc=0
  dati=0
  dats=""
  lnkc=""
  lnkd=""
  stkb=0
  vaf=0
  pakd=0
  ccx=0
  casg=0
  asgb=0
  ebdi=0
  cef=0
  cefi=0
  cbi=1
  defbuf=""
  dimi=0
  cboolf=0
  jn=0
  tmpi=0
  epfx=""
  ppfx=""
  plp=1
  plq=0
  vwb=0
  vwe=0
  asxp=0
  cpoint=0
  sr2=58
  ct2=59
  lpath=""
  ipath=""
  cfile=""
  opers=""
  nsi=0
  nsp=0
  nsq=0
  rps=0
  hiex=""
  mct=0
  independent=0
  cnsl=0
  eord=0
  impo=0
  opns=""
  opnsl=""
  '
  for a=0 to 15  : wva(a)="" : next 'CLEAR DECLARATION BUFFERS
  '
end sub



