'=======
'BUFFERS
'=======


sub insertt(string wt, int p) 'INSERT INTO ASSEMBLY BUFFER
==========================================================
  int le=len(wt)
  if len(t)<j+le then t+=space(le+4000)
  mid(t,p)=wt+mid(t,p,j-p) : j+=le
end sub


sub ape(string*s, int*k, string wt)
===================================
  int le=len(wt)
  if len(s)<k+le then s+=string(le+4096,chr(0))
  mid(s,k+1)=wt : k+=le
end sub


sub appendm(string*s, k*int, string*wt)
=======================================
  int le=len(wt)
  if len(s)<k+le then s+=space(le+4096)
  mid(s,k)=wt : k+=le
end sub


sub appendt(string wt)
======================
  static as int le
  le=len(wt)
  if len(t)<j+le then t+=space(le+0x10000)
  mid(t,j)=wt : j+=le
end sub




'========
'DATABASE
'========


function NewTmpName() as string
'==============================
tmpi+=1 : return chr(127)+str(tmpi)
end function

sub init4(int p, le, c)
=======================
int q at (p)
while le>0
  q=c
  @q+=4
  le-=1
wend
end sub


macro hashcodem(s)
'=================
sys p=strptr(s)
mov edx,0x35db53bd
mov rcx,p
rhashcode:
mov al,[rcx]
cmp al,0
jz nhashcode
rol edx,1
xor dl,al
inc rcx
jmp rhashcode
nhashcode:
mov i,edx
end asm
end macro


'=====================
'STRING POOL FUNCTIONS
'=====================


sub macoin(int m)
=================
 init4 @maco(m*smaco),smaco,0
end sub


sub macsi(string w, int m, n)
=============================
  '
  'STORE STRING IN BUFFER
  'INDEX IT IN MACO (WITH OFFSET OF N)
  '
  int b,le
  n+=omacs
  le=len(w) : if le=0 then maco(m*smaco+n)=0 : exit sub
  b=spe+le+4
  if b>spl then sps+=nuls 1000000
  maco(m*smaco+n)=spe
  mk4(sps,spe,le)
  mid(sps,spe+4)=w
  spe=b
end sub


sub macsp(w as string, byref b as int)
======================================
  int le=len(w)
  mk4(sps,b,le)
  mid(sps,b+4)=w
  b+=le+4
end sub



function macso(m as int, n as int) as string
============================================
  int a,le
  sys p
  int *q
  n+=omacs
  a=maco(m*smaco+n) : if a=0 then exit function
  p=strptr(sps)+a-1
  @q=p
  function=mid(sps,a+4,q)
end function


function cmpsp(string w, int i) as int
======================================
int le
int f
sys p
sys q
p=strptr(sps)
q=strptr(w)
le=len(w)
mov rsi,[p]
add rsi,i
dec rsi
mov rcx,le
cmp ecx,[rsi]
jnz nmstr 'length mismatch
mov qword f,-1 'presume match
add rsi,4
mov rdi,q
dec rsi
dec rdi
inc ecx
rmstr:
  inc rsi
  inc rdi
  dec ecx  ' byte count
  jle nmstr ' ok matched
  mov al,[rsi]
  cmp al,[rdi]
  jz rmstr 'match bytes so continue
mov qword f,0 'mismatch
nmstr:
'if f then if w=mid(sps,i+4,le) then return -1 'WORD MATCH
return f
end function


sub InitDefTables()
'==================
spl=1000000                 'string pool size
sps=nuls spl                'clear string pool
spe=8                       'pool base
init4 @macb(0),512,0        'clear hash table base
init4 @maco(0),me*smaco,0 'clear previous records
me=1                        'reset records boundary
mp=0                        'clear locator index
end sub


function lookupm(string wd) as int
'=================================
'
int a,f,i,m,n,v,w
string wk
nsp=0
dcf=instr(wd,"::")
if dcf then
  dcf+=1
  if dcf=len(wd) then 'LOOKING FOR  THE NAMESPACE ITSELF
    dcf=0
  else
    nsw=left(wd,dcf)
    i=dcf : dcf=0
    nsp=lookupm(nsw)
    nsq=nsp
    dcf=i
  end if
end if

wk=mid(wd,dcf+1)

'hashcodem
sys p=strptr(wk)
'
mov edx,0x35db53bd
mov rcx,p
rhashcode1:
mov al,[rcx]
cmp al,0
jz nhashcode1
rol edx,1
xor dl,al
inc rcx
jmp rhashcode1
nhashcode1:
mov i,edx
'
'TAKE THE BOTTOM 9 BITS OF THE HASH CODE
'TO FORM A BASE INDEX TO SELECT A CHAIN
w=i and 511
v=macb(w)
'
'FIND THE FIRST MATCHING NAME GOING BACKWARDS
f=0
do
  if v<=0 then exit do 'NO MORE IN LIST
  if (mach(v).h=i) then 'MATCHING HASH CODE
    a=0
    n=mach(v).n 'NAMESPACE
    if nsq then
      if n=nsq then a=1 'MATCHING SPECIFIED NAMESPACE NSQ
    else 'nsq=0
      if n then
        if n=nsi then a=1 'MATCHING CURRENT NAMESPACE NSI
      else
        a=1 'NULL NAMESPACE, ALWAYS MATCHING
      end if
    end if
  end if
  if a then
    a=0
    'm=mach(v).m
    m=v
    if m then
      if cmpsp(wk,maco(m*smaco+omacs)) then
        f=m 'MATCH
        exit do
      end if
    end if
  end if
  v=mach(v).l 'NEXT BACKWARDS LINK
loop
nsq=0
return f 'INDEX OF MATCHING NAME OR NULL
'
end function


sub addmin()
'===========
int a,i,v,w
string wd=macso(me,0)
dcf=instr(wd,"::")
if dcf then
  dcf+=1
  if dcf=len(wd) then 'STORING THE NAMESPACE ITSELF
    dcf=0
  else
    nsw=left(wd,dcf)
    i=dcf : dcf=0
    nsq=lookupm(nsw) 'RECURSE TO LOCATE NAMESPACE
    dcf=i
  end if
end if

'hashcodem
sys p=strptr(wd)+dcf
'
mov edx,0x35db53bd
mov rcx,p
rhashcode3:
mov al,[rcx]
cmp al,0
jz nhashcode3
rol edx,1
xor dl,al
inc rcx
jmp rhashcode3
nhashcode3:
mov i,edx
'
if i=0 then ers="zero hash failure: "+macso(me,0) : ert=13 : exit sub
w=i and 511
if me>=maxit then
  ers="Too many entities to include "+macso(me,0) : ert=13 : exit sub
end if
v=me
if nsq then a=nsq else a=nsi
nsq=0
mach(v).h=i       'FULL HASH CODE
mach(v).l=macb(w) 'LINK TO PREVIOUS
mach(v).b=brc     'NESTING LEVEL
mach(v).n=a       'NAMESPACE
macb(w)=v         'SET BASE LINK
if fq then
  maco(v*smaco+6)=sti(fq-1) 'FQL: SOURCE FILENAME INDEX SSN(FQL)
end if
maco(v*smaco+7)=a 'NAMESPACE INDEX
'
end sub


function lookupc(string*wd) as int
'=================================
int v,i
'hashcodem
sys p=strptr(wd)
'
mov edx,0x35db53bd
mov rcx,p
rhashcode2:
mov al,[rcx]
cmp al,0
jz nhashcode2
rol edx,1
xor dl,al
inc rcx
jmp rhashcode2
nhashcode2:
mov [i],edx
'
v=i and 511
do
  if opd(v,0)=i then ' match#
    if wd=opn(v) then exit do ' confirm perfect match
  end if
  v=opd(v,1) : if v=-1 then exit do
loop
return v
end function


sub addm()
'=========
  int a,b
  string wr=macso(me,0)
  if wr="" then exit sub
  a=lookupm(wr)
  if a then
    if uniq then
      if (nsi=0)or(nsi=mach(a).n) then 'BASE NAMESPACE OR MATCHING NAMESPACE
        if mach(a).b=brc then 'WITHIN SAME SCOPE
          ers="'"+wr+"' is already defined"  : ert=13 : exit sub
        end if
      end if
    end if
    'b=maco(a*smaco)
    'if b=-9 then 'or b=-10 'register
    '  ers="'"+wr+"' is a reserved word"  : ert=13 : exit sub 'LIST OF COMMON RESERVED WORDS
    'elseif a<mesb then
    '  ers="'"+wr+"' is a reserved symbol"  : ert=13 : exit sub 'CORE DEFINITIONS
    'end if
  end if
  addmin()
end sub


sub addme()
'==========
  me+=1 : if me>=maxit then ers="Too many definitions" : ert=10 : me=maxit-1
end sub


function capm(int i, k) as string
=================================
  return str(maco(i*smaco+k))+dfd+cr
end function


function writestates(int b, e) as string
========================================
  string s,w1,c
  int i,k,le
  c=dfd+cr
  for i=b to e
    w1=capm(i,0)+capm(i,1)+capm(i,2)+capm(i,3)+capm(i,4)+capm(i,5)+capm(i,6)+capm(i,7)+_
    macso(i,0)+c+macso(i,1)+c+macso(i,2)+c+macso(i,3)+c
    le=len(w1)
    if len(s)<k+le then
      s+=space(8000+le)
    end if
    mid(s,k+1)=w1
    k+=le
  next
  return left(s,k)
end function


function nexm(string s, int*i) as string
========================================
  int k
  k=instr(i,s,dfd)
  if k then
    function=mid(s,i,k-i)
    i=k+3 ' skip dfd followed by cr
  else
    i=len(s)+1
  end if
end function



sub readstates(string s)
========================
  int c,i
  string w1
  i=2
  do
    if i>=len(s) then
      exit do
    end if
    for c=0 to omacs-1
      w1=nexm(s,i)
      maco(me*smaco+c)=wval(w1)
    next
    for c=0 to 3
      w1=nexm(s,i)
      macsi(w1,me,c)
    next
    addm() : addme()
    if ert then exit do
  loop
end sub


sub newrecord(string wr)
========================
  macoin(me)
  macsi(wr,me,0)
  addm()
end sub


sub nest()
==========
  nester*sc
  if brc>99 then ers="Depth limit exceeded ((()))" : ert=10 : exit sub
  brc+=1
  @sc=@scop(brc)
  if lclv then
    aoffl=aoff
  else
    aoffs=aoff
  end if
  sc.me    = me    '0  DATA RECORD BOUNDARY
  sc.aoffl = aoffl '1  LOCAL OFFSET
  sc.aoffs = aoffs '2  STATIC OFFSET
  sc.asce  = asce  '3  ASCENDING / DESCENDING ALLOCATION
  sc.lclv  = lclv  '5  LOCAL
  sc.spe   = spe   '6  STRING POOL END
  sc.ixb   = ixb   '7  ARRAY INDEX BASE
  sc.sr2   = sr2   '8  STATEMENT SEPARATOR 2 (: OR ;)
  sc.ct2   = ct2   '9  COMMENT MARKER 2 (;)
  sc.tys   = tys   '10 SPECIFIED DEFAULT TYPE
  sregs(brc)=regs
end sub


'-----------
sub unnest()
'===========
  nester*sc
  int a,b,c,e
  @sc=@scop(brc)
  e=me-1
  '
  'LOCAL OR STATIC VARIABLES?
  '
  if lclv=0 then aoffs=aoff 'RETAIN STATIC VARSPACE EXPANSION
  '
  me    = sc.me    '0  DATA RECORD BOUNDARY
 'aoffl = sc.aoffl '1  LOCAL OFFSET
 'aoffs = sc.aoffs '2  STATIC OFFSET
  asce  = sc.asce  '3  ASCENDING / DESCENDING ALLOCATION 
  lclv  = sc.lclv  '5  LOCAL
  spe   = sc.spe   '6  STRING POOL END
  ixb   = sc.ixb   '7  ARRAY INDEX BASE
  sr2   = sc.sr2   '8  STATEMENT SEPARATOR 2 (: OR ;)
  ct2   = sc.ct2   '9  COMMENT MARKER 2 (;)
  tys   = sc.tys   '10 SPECIFIED DEFAULT TYPE
  '
  if lclv then aoff=aoffl else aoff=aoffs 'RESTORE PRIOR LOCAL ALLOCATION
  regs=sregs(brc)
  brc-=1
  if brc<0 then
    brc=0
    ers="Too many right brackets (..))" : ert=10
  end if
  'HASH TABLES BACKWARD DISALLOCATION
  for a=e to me step -1
    b=mach(a).l 'PREVIOUS RECORD
    c=mach(a).h and 511 'SHORT HASH
    macb(c)=b
  next
end sub


sub localvars()
===============
 if lclv then
   aoffl=aoff
 else
   aoffs=aoff : regs=regsl
 end if
 lclv=1 : aoff=aoffl : asce=-1
end sub


sub staticvars()
===============
 if lclv then
   aoffl=aoff : regs=regss
 else
   aoffs=aoff
 end if
 lclv=0 : aoff=aoffs : asce=1
end sub


function signedhex(int d) as string
===================================
  if d>0 then
    function="+0x"+hexci(d)
  elseif d<0 then
    function="-0x"+hexci(-d)
  end if
end function


function memreg(string rg, int d) as string
===========================================
  function="["+rg+signedhex(d)+"]"
end function


function memregadj(string mr, int d) as string
==============================================
  int a,b,c,e
  string en="]"
  if asc(mr,len(mr))<=13 then en+=cr
  a=instrevn(-1,mr,"[")
  if isn(asc(mr,a+1)) then
    'adjust absolute addr
    c=a
    e=wval(mid(mr,c+1))
    return left(mr,c)+"0x"+hex(d+e)+en
  else
    c=instr(a,mr,"*") 'index multiplier: *1 *2 *4 *8
    if c then c+=2 else c=5
  end if
  a=asc(mr,c)
  e=wval(mid(mr,c+1))
  if a=45 then e=-e
  return left(mr,c-1)+signedhex(d+e)+en
end function



function newstatvar() as int
============================
  if lclv then
    function=aoffs : aoffs+=cpuw
  else
    function=aoff : aoff+=cpuw : aoffs=aoff
  end if
end function


function newstatvarStr(int*p) as string
=======================================
  p=NewStatVar()
  return memreg(regss,p)
end function


function addlib(string*wr) as int
=================================
  int a
  if wr="" then return 0
  wr=lcase(wr) ' MS case insens
  '
  'SEARCH BACKWARDS
  '----------------
  '
  a=libe
  do
    a-=1
    if a<dlb then exit do 'DLB INIT = 1
    if wr=libs(a) then exit do
  loop
  '
  'ASSIGN NEW
  '----------
  '
  if a<1 then
    a=libe 'LIBE INIT = 1
    libu(a)=0
    '
    'ALWAYS STORE IN STATIC VARIABLE
    '
    libo(a)=newstatvar()
    libs(a)=wr
    libe+=1
    '
    'CHECK LIMIT
    '-----------
    '
    if libe>510 then libe=510 : ert=300 : ers="Too many libraries"
  end if
  '
  function=a
  '
end function




function addlproc(int pd, string wa) as string
==============================================
  '
  'FORMAT : o2 ( ...02 h?xxxxxxxx `name` 00 ...
  '
  '
  int a,b,c,d,e,lw
  string wr,w1
  '
  'SELECT LIB BUFFER
  '-----------------
  '
  c=libu(pd)    'LIB BUFF USED
  w1="`"+wa+"` 00" 'LOCATE ALIAS
  '
  '
  'CHECK IF ALREADY PRESENT
  '------------------------
  '
  d=instr(libl(pd),w1)
  '
  if (d>0)and(d<c) then
  'EXTRACT PREVIOUS VECTOR
    a=instrevn(d-2,libl(pd),"h")+2
    return "["+qebx+"+0x"+yword(libl(pd),a)+"]"
  end if
  '
  'OTHERWISE CREATE NEW STATIC VAR
  '-------------------------------
  '
  a=newstatvar()
  '
  'CREATE A NEW VECTOR
  '-------------------
  '
  if cpuw=4 then
    wr="02 hl"+hexci(a)+" "+w1+cr 'LINK DATA
  else 'cpuw=8
    wr="02 hq"+hexci(a)+" "+w1+cr 'LINK DATA
  end if
  '
  lw=len(wr)
  '
  '
  'EXTEND BUFFER IF NEEDED
  '-----------------------
  '
  e=len(libl(pd))
  if e<c+lw+1 then libl(pd)+=space(2048)
  '
  'APPEND PROC NAME AND REGSS OFFSET TO LIST
  '-----------------------------------------
  '
  mid(libl(pd),c+1)=wr
  libu(pd)=c+lw
  '
  impo=1
  return memreg(qebx,a) 'RETURN STATIC OFFSET
  '
end function



function StoreCode(string*s) as string
======================================
string wr
if len(s)=0 then exit function
tmpi+=1 : wr="_code"+str(tmpi)
newrecord(wr)
if ert then exit function
macsi(s,me,1)
maco(me*smaco)=-21
addme
s=""
return wr
end function

