

  uses MathUtil


  '
  'equates from glext.h
  '======
  '
  % GL_ARRAY_BUFFER         0x8892

  % GL_ELEMENT_ARRAY_BUFFER 0x8893

  % GL_STATIC_DRAW          0x88E4

  '

  /* Shaders */

  % GL_FRAGMENT_SHADER                   0x8B30

  % GL_GEOMETRY_SHADER                   0x8DD9
  % GL_VERTEX_SHADER                     0x8B31

  % GL_MAX_VERTEX_ATTRIBS                0x8869

  % GL_MAX_VERTEX_UNIFORM_VECTORS        0x8DFB

  % GL_MAX_VARYING_VECTORS               0x8DFC

  % GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS  0x8B4D

  % GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS    0x8B4C

  % GL_MAX_TEXTURE_IMAGE_UNITS           0x8872

  % GL_MAX_FRAGMENT_UNIFORM_VECTORS      0x8DFD

  % GL_SHADER_TYPE                       0x8B4F

  % GL_DELETE_STATUS                     0x8B80

  % GL_LINK_STATUS                       0x8B82

  % GL_VALIDATE_STATUS                   0x8B83

  % GL_ATTACHED_SHADERS                  0x8B85

  % GL_ACTIVE_UNIFORMS                   0x8B86

  % GL_ACTIVE_UNIFORM_MAX_LENGTH         0x8B87

  % GL_ACTIVE_ATTRIBUTES                 0x8B89

  % GL_ACTIVE_ATTRIBUTE_MAX_LENGTH       0x8B8A

  % GL_SHADING_LANGUAGE_VERSION          0x8B8C

  % GL_CURRENT_PROGRAM                   0x8B8D

  /* Shader Source */

  % GL_COMPILE_STATUS                    0x8B81

  % GL_INFO_LOG_LENGTH                   0x8B84

  % GL_SHADER_SOURCE_LENGTH              0x8B88

  % GL_SHADER_COMPILER                   0x8DFA

  '
  % GL_TEXTURE_CUBE_MAP                  0x8513
  % GL_TEXTURE_BINDING_CUBE_MAP          0x8514
  % GL_TEXTURE_CUBE_MAP_POSITIVE_X       0x8515
  % GL_TEXTURE_CUBE_MAP_NEGATIVE_X       0x8516
  % GL_TEXTURE_CUBE_MAP_POSITIVE_Y       0x8517
  % GL_TEXTURE_CUBE_MAP_NEGATIVE_Y       0x8518
  % GL_TEXTURE_CUBE_MAP_POSITIVE_Z       0x8519
  % GL_TEXTURE_CUBE_MAP_NEGATIVE_Z       0x851A
  % GL_PROXY_TEXTURE_CUBE_MAP            0x851B
  % GL_MAX_CUBE_MAP_TEXTURE_SIZE         0x851C
  '
  % GL_TEXTURE_CUBE_MAP_SEAMLESS      0x884F
  '
  % GL_GENERATE_MIPMAP                0x8191
  % GL_TEXTURE_MAX_ANISOTROPY_EXT     0x84FE
  % GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT 0x84FF
  % GL_CLAMP_TO_EDGE                  0x812F
  '
  % GL_PRIMITIVE_RESTART_FIXED_INDEX  0x8D69

  '
  % GL_TEXTURE0                       0x84C0 '0..31
  % GL_ACTIVE_TEXTURE_ARB             0x84E0
  '
  '% GL_HALF_FLOAT_ARB                 0x140B
  '% GL_ARB_half_float_pixel 1
  '% GL_ARB_half_float_vertex 1
  typedef unsigned short GLhalf;

  '
function FloatToHalfFloat(sys pf,ph,n) as GLhalf*
=================================================
'
'USE OF REGISTERS:
'edx sign transform
'eax exponent transform
'ecx significand transform
'esi source pointer
'edi dest pointer
'
mov esi,pf
mov edi,ph
(
  dec dword n
  jl exit
  mov ecx,[esi]
  mov edx,ecx
  mov eax,ecx
  and edx,0x80000000 'mask sign bit
  shr edx,0x10       'shove sign bit down 16
  (
   'TEST FOR 0
   test eax,0x7fffffff
   jnz exit
   jmp fwd nzero
  )
  shr eax,0x17       'shove exponent down 23
  and eax,0xff       'mask exponent 8 bits
  shr ecx,0x0d       'reduce significand 23 bits to 10 bits
  sub eax,0x70       'adjust exponent bias -112 == (15-127)
  (
    'TEST FOR UNDER / OVER / INFINITY / NAN
    (
      cmp eax,0
      jg exit
      mov eax,0 'CLAMP ZERO
      jmp fwd nzero
    )
    cmp eax,0x1f
    jle exit
    mov eax,0x7c00 'CLAMP INFINITY
    jmp fwd nzero
  )  
  shl eax,0x0a       'place exponent 10 bits up
  and ecx,0x3ff      'mask significand 10 bits
  or  eax,ecx
  nzero:
  or  eax,edx
  mov [edi],ax
  add esi,4
  add edi,2
  repeat
)
return ph
end function

'#recordof FloatToHalfFloat


  'declare pointered functions
  '===========================
  '
  extern
  '
  !*glActiveTexture  (int texture)
  !*glClientActiveTexture  (int texture)
  !*glMultiTexCoord2f(int i float s,t)
  '
  'Shaders
  !*glCreateShader       (int shadertype) as int

  !*glShaderSource       (int shader,count,sys strings, int lengths)

  !*glCompileShader      (int shader)

  !*glGetShaderInfoLog   (int shader,maxlength,*length,char*infolog)  
  !*glGetProgramInfoLog  (int shader,maxlength,*length,char*infolog)

  !*glGetShaderiv        (int shader,pname,*params)

  !*glAttachShader       (int program,shader)

  !*glDetachShader       (int program,shader)

  !*glDeleteShader       (int shader)

  !*glLinkProgram        (int program)

  !*glCreateProgram      () as int

  !*glDeleteProgram      (int program)

  !*glGetProgramiv       (int program,pname,*params)

  !*glUseProgram         (int program)

  !*glGetUniformLocation (int program, char*name) as int

  !*glGetUniformfv       (int program,location,float*params)

  !*glUniform1i          (int location, int v)

  !*glUniform1f          (int location, float v1)

  !*glUniform2f          (int location, float v1,v2)

  !*glUniform3f          (int location, float v1,v2,v3)

  !*glUniform4f          (int location, float v1,v2,v3,v4)

  !*glUniform1iv         (int location, count, int*v)

  !*glUniform1fv         (int location, count, float *v)

  !*glUniform2fv         (int location, count, float *v)

  !*glUniform3fv         (int location, count, float *v)

  !*glUniform4fv         (int location, count, float *v)

  !*glUniformMatrix3fv   (int location, count, transpose, float *v)

  !*glUniformMatrix4fv   (int location, count, transpose, float *v)

  '
  'VERTEX BUFFER OBJECTS
  !*glGenBuffers(int n, *buffers)
  !*glBindBuffer(sys target, buffer)
  !*glBufferData(sys target, size, pdat, usage)
  !*glDeleteBuffers(int n, *buffers)
  '
  'ATTRIBUTE ARRAY
  !* glVertexAttribPointer (int index, size, type, normalized, stride, pointer)
  !* glVertexAttribDivisor( int location, divisor )
  !* glGetAttribLocation(int program, char* name)
  !* glEnableVertexAttribArray(int location)
  !* glDisableVertexAttribArray(int location)
  'MULTIDRAW
  !* glMultiDrawArrays( int mode, *first, *count, primcount)
  !* glMultiDrawElements( int mode, *count, type, **indices, primcount)
  'BASE VERTEX
  !* glDrawElementsBaseVertex( int mode, count, type, *indices, basevertex)
  'INSTANCE
  !* glDrawArraysInstanced( int mode, first, count, instancecount)
  !* glDrawElementsInstanced( int mode, GLsizei count, type, *indices, instancecount )
  !* glDrawArraysInstancedBaseInstance( int mode, first, count, instancecount, baseinstance)
  'RANGE
  !* glDrawElementsInstancedBaseInstance( int mode, count, type, *indices, instancecount, baseinstance)
  !* glDrawRangeElements( int mode, start, end, count, type, *indices)
  'COMBINATIONS
  !* glMultiDrawElementsBaseVertex( int mode, *count, type, **indices, primcount, *basevertex )
  !* glDrawRangeElementsBaseVertex( int mode, start, end, count, type, *indices, basevertex )
  !* glDrawElementsInstancedBaseVertex( int mode, count, type, *indices, instancecount, basevertex )
  !* glDrawElementsInstancedBaseVertexBaseInstance( int mode, count, type, *indices, instancecount, basevertex, baseinstance )
  'FEEDBACK
  !* glDrawTransformFeedback( int mode, id)
  !* glDrawTransformFeedbackStream( int mode, id, stream )
  !* glDrawTransformFeedbackInstanced( int mode, id, instancecount )
  !* glDrawTransformFeedbackStreamInstanced( int mode, id, stream, instancecount )
  'INDIRECT
  !* glDrawArraysIndirect( int mode, *indirect )
  type DrawArraysIndirectCommand { int  count, instanceCount, first, baseInstance }
  !* glMultiDrawArraysIndirect( int mode, *indirect, drawcount, stride )
  !* glDrawElementsIndirect( int mode, type, *indirect )
  type  struct DrawElementsIndirectCommand { int count, instanceCount, firstIndex, baseVertex, baseInstance }
  !* glMultiDrawElementsIndirect( int mode, type, *indirect, drawcount, stride )
  'CONDITIONAL RENDERING
  % GL_QUERY_NO_WAIT
  % GL_QUERY_BY_REGION_WAIT
  % GL_QUERY_BY_REGION_NO_WAIT
  !* glBeginConditionalRender( INT id, mode )
  !* glEndConditionalRender()
  '
  ' 
  '!* glColor3hv          (GLhalf*v)
  '!* glColor4hv          (GLhalf*v)
  '!* glVertex3hv         (GLhalf*v)
  '!* glNormal3hv         (GLhalf*v)
  '!* glTexCoord2hv       (GLhalf*v)
  '!* glMultiTexCoord2hv  (sys target, GLhalf*v)
  '!* glFogCoordhv        (GLhalf*v)

  end extern
  '
  sys ShaderError
  '
  macro SetFunARB(name)
  ===================

  @name=wglGetProcAddress ""#name#"ARB"
  if @name=0 then print ""#name#"ARB ?" ': exit sub

  end macro


  macro SetFunNV(name)
  ===================

  @name=wglGetProcAddress ""#name#"NV"
  if @name=0 then print ""#name#"NV ?" ': exit sub

  end macro




  sub SetupExtFunctions()
  =======================
  '
  'bind to buffer functions
  '
  SetFun glGenBuffers
  SetFun glBindBuffer
  SetFun glBufferData
  SetFun glDeleteBuffers
  '
  SetFun glActiveTexture
  SetFun glClientActiveTexture
  SetFun glMultiTexCoord2f
  '
  'bind to GLSL functions
  SetFun glCreateShader

  SetFun glShaderSource

  SetFun glCompileShader

  SetFun glGetShaderInfoLog
  SetFun glGetProgramInfoLog

  SetFun glGetShaderiv

  SetFun glAttachShader

  SetFun glDetachShader

  SetFun glDeleteShader

  SetFun glLinkProgram

  SetFun glCreateProgram

  SetFun glDeleteProgram

  SetFun glGetProgramiv

  SetFun glUseProgram

  SetFun glGetUniformLocation

  SetFun glGetUniformfv

  SetFun glUniform1i

  SetFun glUniform1f

  SetFun glUniform2f

  SetFun glUniform3f

  SetFun glUniform4f
  SetFun glUniform1iv

  SetFun glUniform1fv

  SetFun glUniform2fv

  SetFun glUniform3fv

  SetFun glUniform4fv
  SetFun glUniformMatrix3fv

  SetFun glUniformMatrix4fv
  '
  'ATTRIBUTE ARRAY
  SetFun glGetAttribLocation
  SetFun glVertexAttribPointer
  SetFun glVertexAttribDivisor
  SetFun glEnableVertexAttribArray
  SetFun glDisableVertexAttribArray
  'MULTIDRAW
  SetFun glMultiDrawArrays
  SetFun glMultiDrawElements
  'BASE VERTEX
  SetFun glDrawElementsBaseVertex
  'INSTANCE
  SetFun glDrawArraysInstanced
  SetFun glDrawElementsInstanced
  SetFun glDrawArraysInstancedBaseInstance
  'RANGE
  SetFun glDrawElementsInstancedBaseInstance
  SetFun glDrawRangeElements
  'COMBINATIONS
  SetFun glMultiDrawElementsBaseVertex
  SetFun glDrawRangeElementsBaseVertex
  SetFun glDrawElementsInstancedBaseVertex
  SetFun glDrawElementsInstancedBaseVertexBaseInstance
  'FEEDBACK
  SetFun glDrawTransformFeedback
  SetFun glDrawTransformFeedbackStream
  SetFun glDrawTransformFeedbackInstanced
  SetFun glDrawTransformFeedbackStreamInstanced
 ''INDIRECT
  SetFun glDrawArraysIndirect
  type DrawArraysIndirectCommand { int  count, instanceCount, first, baseInstance }
  SetFun glMultiDrawArraysIndirect
  SetFun glDrawElementsIndirect
  type  struct DrawElementsIndirectCommand { int count, instanceCount, firstIndex, baseVertex, baseInstance }
  SetFun glMultiDrawElementsIndirect
  'CONDITIONAL RENDERING
  % GL_QUERY_NO_WAIT
  % GL_QUERY_BY_REGION_WAIT
  % GL_QUERY_BY_REGION_NO_WAIT
  SetFun glBeginConditionalRender
  SetFun glEndConditionalRender
  '
  '
  'extern 
  '!* glColor3hv          (GLhalf*v)
  '!* glColor4hv          (GLhalf*v)
  '!* glVertex3hv         (GLhalf*v)
  '!* glNormal3hv         (GLhalf*v)
  '!* glTexCoord2hv       (GLhalf*v)
  '!* glMultiTexCoord2hv  (sys target, GLhalf*v)
  '!* glFogCoordhv        (GLhalf*v)
  'end extern
  '
  'FUNCTIONS USING HALF-FLOATS
  'SetFunNV glColor3hv
  'SetFunNV glColor4hv
  'SetFunNV glVertex3hv
  'SetFunNV glNormal3hv
  'SetFunNV glTexCoord2hv
  'SetFunNV glMultiTexCoord2hv
  'SetFunNV glFogCoordhv
  '
  'tests
  'GLhalf h[100]
  'glColor3hv h
  '#recordof GLhalf
  'sys f(GLhalf*v){print v}
  '#show f h
  '#show GLhalf h={0x3c00,0x3c00,0x3c00}

  end sub

  
  '
  function instrword(string s,k) as sys
  =====================================
  sys a,e
  do
    a=instr a+1,s,k
    if a then
      if a>1
        if asc (s,a-1)>32 then continue do
      end if
      e=a+len k
      if asc(s,e)>32 then continue do
    end if
    exit do
  end do
  return a
  end function


  function replace(string s,f,r) as string

  ========================================

  if not f then return

  if not s then return

  sys ls=len s

  sys lf=len f

  sys lr=len r

  sys b=1,i=1,j=1

  sys lt,d

  string t

  do

    i=instr(b,s,f)

    if i=0 then exit do

    d=i-b+lr

    if lt<j+d-1

      t+=nuls ls*2 : lt=len t

    end if

    mid t,j,mid(s,b,i-b)+r

    j+=d

    b=i+lf

  end do

  return left t,j-1

  end function



  function GetShaderInfoLog(int shader,string *info) as sys
  =========================================================
  sys le,li
  'glGetShaderiv shader, GL_SHADER_SOURCE_LENGTH , le
  'print "Source length" le

  glGetShaderiv shader, GL_INFO_LOG_LENGTH , le
  'print "Log Length " le
  if le>1

    info=nuls le

    glGetShaderInfoLog shader, le, li, Info

    info = replace left(Info,li), chr(10), chr(13)+chr(10)

  end if
  return li 'log length
  end function


  function GetProgramInfoLog(int program,string *info) as sys
  ===========================================================
  sys le,li
  glGetProgramiv program, GL_INFO_LOG_LENGTH , le
  if le>1

    info=nuls le

    glGetProgramInfoLog program, le, li, Info

    info = replace left(Info,li), chr(10), chr(13)+chr(10)

  end if
  return li 'log length
  end function


  sub CompileShader(int typ, string s , int *h,*c)
  ================================================
  sys sa,sl
  h = glCreateShader typ
  sa = strptr s : sl=len s
  glShaderSource h, 1, @sa, @sl

  glCompileShader h

  glGetShaderiv h, GL_COMPILE_STATUS, c

  if c=0
    string vlog
    if GetShaderInfoLog(h,vlog)
      print vlog
    end if

    ShaderError=2
  end if
  end sub


  class ShaderProg
  ================
  '
  ! CreateShaderProg(ShaderProg*p) as sys

  ! ReleaseShaderProg(ShaderProg*p) as sys

  '
  string vsrc , gsrc , fsrc       'vertex, geometry, fragment shader sources
  int    ph                       'program handle
  int    vh   , gh   , fh         'vertex, geometry, fragment shader handles
  int    vc   , gc   , fc         'vertex, geometry, fragment shader compile status
  int    m0,m1,m2,m3,m4,m5,m6,m7  '4x4 matrix locators
  int    n0,n1,n2,n3,n4,n5,n6,n7  '3x3 matrix locators
  int    t0,t1,t2,t3,t4,t5,t6,t7  'texture or sampler locators
  int    u0,u1,u2,u3,u4,u5,u6,u7  'general locators
  int    v0,v1,v2,v3,v4,v5,v6,v7  'vec4 locators
  '
  method create()
  #ifdef shan
   indexbase 1
   shae+=1
   shan[shae]=@this
  #endif
  CreateShaderProg this
  end method
  '
  method use()
  glUseProgram ph
  end method
  '
  method release()
  ReleaseShaderProg this
  end method

  end class
  

  function CreateShaderProg(ShaderProg*p) as sys

  ==============================================

  'http://www.opengl.org/sdk/docs/tutorials/ClockworkCoders/loading.php

  '
  if p.vsrc="" or p.fsrc="" then
    ShaderError = 1
    jmp fwd done
  end if

  '
  CompileShader GL_VERTEX_SHADER, p.vsrc, p.vh, p.vc
  CompileShader GL_FRAGMENT_SHADER, p.fsrc, p.fh, p.fc
  if p.gsrc then
    CompileShader GL_GEOMETRY_SHADER, p.gsrc, p.gh, p.gc
  end if
  'if ShaderError then jmp fwd done
  '

  'LINKING SHADERS TO PROGRAM

  '
  p.ph = glCreateProgram
  glAttachShader p.ph, p.vh

  if p.gsrc then glAttachShader p.ph, p.gh

  glAttachShader p.ph, p.fh

  glLinkProgram p.ph

  sys linked

  glGetProgramiv p.ph, GL_LINK_STATUS, linked

  if not linked
    string infolog
    if GetProgramInfoLog(p.ph, infolog)
      print infolog
    end if
    ShaderError=3
  end if
  '

  done:
  return p.ph
  end function


  function ReleaseShaderProg(ShaderProg*p) as sys

  ===============================================
  if not p.ph then exit function
  if p.fc then glDetachShader p.ph, p.fh
  if p.gc then glDetachShader p.ph, p.gh
  if p.vc then glDetachShader p.ph, p.vh
  if p.fc then glDeleteShader p.fh
  if p.gc then glDeleteShader p.gh
  if p.vc then glDeleteShader p.vh
  glDeleteProgram p.ph
  p={"","","",0,0,0,0,0,0,0}
  end function




  function CreateTexture2D(int width, height, sys *img, int *texture)
  ===================================================================
  glGenTextures(1, Texture)
  glBindTexture(GL_TEXTURE_2D, Texture);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR)
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR)
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, 4)
  glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_TRUE)
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, Width, Height, 0, GL_RGBA, GL_UNSIGNED_BYTE, img[1])
  glBindTexture(GL_TEXTURE_2D, 0)
  end function


  function CreateTextureCubic(int width, height, sys *img, int *texture)
  ======================================================================
  glGenTextures(1, Texture)
  glBindTexture(GL_TEXTURE_CUBE_MAP, Texture)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAG_FILTER, GL_LINEAR)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAX_ANISOTROPY_EXT, 4)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_GENERATE_MIPMAP, GL_TRUE)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_CUBE_MAP_SEAMLESS, GL_TRUE)
  sys i
  '% GL_TEXTURE_CUBE_MAP_POSITIVE_X    0x8515
  '% GL_TEXTURE_CUBE_MAP_NEGATIVE_X    0x8516
  '% GL_TEXTURE_CUBE_MAP_POSITIVE_Y    0x8517
  '% GL_TEXTURE_CUBE_MAP_NEGATIVE_Y    0x8518
  '% GL_TEXTURE_CUBE_MAP_POSITIVE_Z    0x8519
  '% GL_TEXTURE_CUBE_MAP_NEGATIVE_Z    0x851A
  for i=1 to 6
    glTexImage2D(GL_TEXTURE_BINDING_CUBE_MAP + i, 0, GL_RGBA8, Width, Height, 0, GL_RGBA, GL_UNSIGNED_BYTE, img[i] )
  next
  glBindTexture(GL_TEXTURE_CUBE_MAP, 0)
  end function


  function MakeSimpleTexture(int*texture)
  =======================================
  string tex
  tex=nuls (128*128*4)
  int c,i
  sys e=128*128
  int q at strptr tex
  for i=0,i<e
    'q=0xffc08000+c*2
     q=0x30c08000+c*2
     @q+=4
     c+=1
  next
  sys p=strptr tex
  CreateTexture2D(128,128,p,texture)
  end function


  sub LoadCubicTextures(string left,right,bottom,top,front,back, int *Texture)
  ============================================================================
  sys i,wi,ht
  string tx[6]
  '1 for no-flip
  LoadPixImage left,   0,tx[2], wi,ht,0 'left
  LoadPixImage right,  0,tx[1], wi,ht,0 'right
  LoadPixImage bottom, 0,tx[4], wi,ht,0 'bottom
  LoadPixImage top,    0,tx[3], wi,ht,0 'top
  LoadPixImage front,  0,tx[5], wi,ht,0 'front
  LoadPixImage back,   0,tx[6], wi,ht,0 'back
'tx[1]=nuls 256*256*4
  '
  'right   pos x
  'left    neg x
  'top     pos y
  'bottom  neg y
  'front   pos z
  'back    neg z
  '
  glGenTextures(1, Texture)
  glBindTexture(GL_TEXTURE_CUBE_MAP, Texture)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAG_FILTER, GL_LINEAR)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAX_ANISOTROPY_EXT, 4)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_GENERATE_MIPMAP, GL_TRUE)
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_CUBE_MAP_SEAMLESS, GL_TRUE)
  for i=1 to 6
    sys p = strptr tx[i]
    glTexImage2D(GL_TEXTURE_BINDING_CUBE_MAP + i, 0, GL_RGBA8, wi, ht, 0, GL_RGBA, GL_UNSIGNED_BYTE, p )
  next
  glBindTexture(GL_TEXTURE_CUBE_MAP, 0)
  end sub



  function MakeSimpleCubicTexture(int*texture)
  ============================================
  string tex[6]
  sys texcube[6]
  tex[1]=nuls (128*128*4)
  tex[2]=nuls (128*128*4)
  tex[3]=nuls (128*128*4)
  sys c,i
  sys e=128*128
  int *q
  ' 
  @q=strptr tex[1]
  c=0
  for i=0,i<e
     q=0xffc08000+c*2 : c++
     'q=0xffc00000
     @q+=4
  next
  
  @q=strptr tex[2]
  c=0
  for i=0,i<e
     q=0xff80c000+c*2 : c++
     'q=0xff00c000
     @q+=4
  next
  
  @q=strptr tex[3]
  c=0
  for i=0,i<e
     q=0xffc0a000+c*2 : c++
     'q=0xff0000c0
     @q+=4
  next
  
  texcube[1]=strptr tex[1]
  texcube[2]=strptr tex[2]
  texcube[3]=strptr tex[1]
  texcube[4]=strptr tex[2]
  texcube[5]=strptr tex[1]
  texcube[6]=strptr tex[2]
  '
  CreateTextureCubic(128,128,texcube,texture) 'TEXTURE RETURNED
  '
  end function


  int    SkyBoxVBO[2]
  '
  sub BuildSkyBox()
  =================
  indexbase 1
  '24 vertics == 72 floats == 288 bytes
  float Vertices[72] = {
     ' x, y, z, ...
     '===============   ================   ================   ================ ====
     1.0, -1.0, -1.0,   1.0, -1.0,  1.0,   1.0,  1.0,  1.0,   1.0,  1.0, -1.0, ' +X
    -1.0, -1.0,  1.0,  -1.0, -1.0, -1.0,  -1.0,  1.0, -1.0,  -1.0,  1.0,  1.0, ' -X
    -1.0,  1.0, -1.0,   1.0,  1.0, -1.0,   1.0,  1.0,  1.0,  -1.0,  1.0,  1.0, ' +Y
    -1.0, -1.0,  1.0,   1.0, -1.0,  1.0,   1.0, -1.0, -1.0,  -1.0, -1.0, -1.0, ' -Y
    -1.0, -1.0,  1.0,   1.0, -1.0,  1.0,   1.0,  1.0,  1.0,  -1.0,  1.0,  1.0, ' +Z
    -1.0, -1.0, -1.0,   1.0, -1.0, -1.0,   1.0,  1.0, -1.0,  -1.0,  1.0, -1.0  ' -Z
  }
  '  1.0, -1.0, -1.0,  -1.0, -1.0, -1.0,  -1.0,  1.0,  1.0,   1.0,  1.0, -1.0  ' -Z

/*
  float Normals =
  {  ' x, y, z, ...
     '===============   ================   ================   ================ ====
     1.0,  0.0,  0.0,   1.0,  0.0,  0.0,   1.0,  0.0,  0.0,   1.0,  0.0,  0.0, ' +X
    -1.0,  0.0,  0.0,  -1.0,  0.0,  0.0,  -1.0,  0.0,  0.0,  -1.0,  0.0,  0.0, ' -X
     0.0,  1.0,  0.0,   0.0,  1.0,  0.0,   0.0,  1.0,  0.0,   0.0,  1.0,  0.0, ' +Y
     0.0, -1.0,  0.0,   0.0, -1.0,  0.0,   0.0, -1.0,  0.0,   0.0, -1.0,  0.0, ' -Y
     0.0,  0.0,  1.0,   0.0,  0.0,  1.0,   0.0,  0.0,  1.0,   0.0,  0.0,  1.0, ' +Z
     0.0,  0.0, -1.0,   0.0,  0.0, -1.0    0.0,  0.0, -1.0    0.0,  0.0, -1.0  ' -Z
  }
*/
  '
  glGenBuffers(1, SkyBoxVBO)
  glBindBuffer(GL_ARRAY_BUFFER, SkyBoxVBO[1])
  glBufferData(GL_ARRAY_BUFFER, 288, @Vertices, GL_STATIC_DRAW)
  'glBindBuffer(GL_ARRAY_BUFFER, SkyBoxVBO[2])
  'glBufferData(GL_ARRAY_BUFFER, 288, @Normals, GL_STATIC_DRAW)
  glBindBuffer(GL_ARRAY_BUFFER, 0)
  end sub

  sub SkyBox()
  ============
  glBindBuffer(GL_ARRAY_BUFFER, SkyBoxVBO)
  glEnableClientState(GL_VERTEX_ARRAY)
  glVertexPointer(3, GL_FLOAT, 0, null)
  glDrawArrays(GL_QUADS, 0, 24)
  glDisableClientState(GL_VERTEX_ARRAY)
  glBindBuffer(GL_ARRAY_BUFFER, 0)
  end sub

/*
  sub SkyBoxNorm()
  ============
  glEnableClientState(GL_VERTEX_ARRAY)
  glEnableClientState(GL_NORMAL_ARRAY)
  glBindBuffer(GL_ARRAY_BUFFER, SkyBoxVBO[1])
  glVertexPointer(3, GL_FLOAT, 0, null)
  glBindBuffer(GL_ARRAY_BUFFER, SkyBoxVBO[2])
  glNormalPointer(   GL_FLOAT, 0, null)
  glDrawArrays(GL_QUADS, 0, 24)
  glDisableClientState(GL_VERTEX_ARRAY)
  glDisableClientState(GL_NORMAL_ARRAY)
  glBindBuffer(GL_ARRAY_BUFFER, 0)
  end sub
*/

  macro UseShader(p)
  ==================
  glUseProgram p
  end macro

  macro ShaderTexture(u,c,n)
  ==========================
  glUniform1i(u, c);
  glActiveTexture(GL_TEXTURE0+c);
  texture n 'openglsceneframe.inc
  end macro

  macro ShaderVector1(a,n,v)
  ==========================
  glUniform1fv a, n, v 
  end macro

  macro ShaderVector2(a,n,v)
  ==========================
  glUniform2fv a, n, v 
  end macro

  macro ShaderVector3(a,n,v)
  ==========================
  glUniform3fv a, n, v 
  end macro

  macro ShaderVector4(a,n,v)
  ==========================
  glUniform4fv a, n, v 
  end macro

  macro ShaderMatrix3(a,n,nf,v)
  =============================
  glUniformMatrix3fv a, n, nf, v 
  end macro

  macro ShaderMatrix4(a,n,nf,v)
  =============================
  glUniformMatrix4fv a, n, nf, v 
  end macro


  class BufferObject
  ==================
  '
  string es,ms,vs  'source buffers
  sys    ei,mi,vi  'source buffer length used
  sys    eb,mb,vb  'opengl buffer names
  sys    ec,mc,vc  'count of elements / matrixes / vertexes
  sys    em,mm,vm  'mode (default GL_TRIANGLES)
  '

  'n count in floats or ints

  method append(string *s, sys p, int n,*ee) as sys
  sys e,i,q
  e=len(s)
  q=n*4 'int or float BYTE-COUNT
  if q+ee>e then s+=nuls(0x4000)+q 'STRETCH BUFFER
  int f at strptr(s)+ee
  int g at p
  for i=1 to n : f=g : @f+=4 : @g+=4 : next
  ee+=q
  end method

  method putvertex(float*d, int n) as sys
  append vs,@d,n,vi
  vc=vi>>5 'vert norm tex
  end method

  method putindex(int*d, int n, m=GL_TRIANGLES) as sys
  if m then em=m
  append es,@d,n,ei
  ec=ei>>2
  end method

  method putmatrix(float*d, int n) as sys
  append ms,@d,n,mi
  mc=mi>>6 '4x4 matrix
  end method

  method clearVertex()
  vi=0 : vc=0
  end method

  method clearIndex()
  ei=0 : ec=0 : em=0
  end method

  method clearMatrix()
  mi=0 : mc=0
  end method

  method init(int mo=0)
  glGenBuffers  1, vb
  glGenBuffers  1, mb
  glGenBuffers  1, eb
  '
  'ATTRIBUTE LOCATION NAMES
  % v_vertex = 0
  % v_normal = 1
  % v_texcor = 2
  % v_tan    = 3
  % v_bitan  = 4
  % v_matrix = 5 '5 6 7 8 (each column of the matrix)

  int i : for i= 0 to 8 : glEnableVertexAttribArray i : next
  int stride = 32 '(3+3+2)*sizeof float
  if mo=1 then stride+=24 '(3+3)*sizeof float 'TAN AND BITAN FOR NORMAL MAPPING
  '
  % vap   =  glVertexAttribPointer
  % f     =  GL_FLOAT
  '
  glBindBuffer GL_ARRAY_BUFFER, vb
  '
  '--------------------------------------------
  'call attribute    n  type nrm stride  offset
  '--------------------------------------------
  vap   v_vertex   , 3, f,   0,  stride, 00 '0
  vap   v_normal   , 3, f,   0,  stride, 12 '3
  vap   v_texcor   , 2, f,   0,  stride, 24 '6
  if mo then
  vap   v_tan      , 3, f,   0,  stride, 32 '8
  vap   v_bitan    , 3, f,   0,  stride, 44 '11
  endif
  

  glBindBuffer GL_ARRAY_BUFFER, mb
  '
  for i=0 to 3
  'call attribute    n  type nrm stride offset
  '-------------------------------------------
  vap   v_matrix+i , 4, f,   0,  64,    i*16 '0 4 8 12
  '-------------------------------------------
  glVertexAttribDivisor(v_matrix+i, 1)
  next
  glBindBuffer GL_ARRAY_BUFFER, 0
  end method

  method transferVertex()
  glBindBuffer GL_ARRAY_BUFFER, vb
  glBufferData GL_ARRAY_BUFFER, vi, strptr(vs), GL_STATIC_DRAW
  end method

  method transferMatrix()
  glBindBuffer GL_ARRAY_BUFFER, mb
  glBufferData GL_ARRAY_BUFFER, mi, strptr(ms), GL_STATIC_DRAW
  end method

  method transferElement()
  glBindBuffer GL_ELEMENT_ARRAY_BUFFER, eb
  glBufferData GL_ELEMENT_ARRAY_BUFFER, ei, strptr(es), GL_STATIC_DRAW
  end method

  method show()
  string tab=chr(9), cm=chr(44), cr=chr(13,10)
  print "BUFFER OBJECT DATA" cr cr+
  tab "vertex" tab "matrix" tab "index" cr+
  "names:" tab vb tab mb tab eb cr+
  "count:" tab vc tab mc tab ec cr+
  "size:" vi tab mi tab ei cr+
   ""
  end method

  method transfer()
  'show 
  transferVertex
  transferMatrix
  transferElement
  end method

  method release()
  'sys i : for i= 0 to 8 : glDisableVertexAttribArray i : next
  def delete glDeleteBuffers
  delete  1, vb 
  delete  1, eb
  delete  1, mb
  end method

  method render(int m=0)
  'INDEXED
  if m then em=m
  'glEnableClientState( GL_VERTEX_ARRAY )
   glBindBuffer GL_ELEMENT_ARRAY_BUFFER, eb
  'sys i : for i= 0 to 8 : glEnableVertexAttribArray i : next
   glDrawElementsInstanced( em, ec, GL_UNSIGNED_INT, null, mc )
  'glDrawElementsInstancedBaseVertex( em, ec, GL_UNSIGNED_INT, null, mc, 0 )
  'glDrawElementsInstancedBaseVertexBaseInstance( em, ec, GL_UNSIGNED_INT, null, mc, 0, 0 )
  'sys i : for i= 0 to 8 : glDisableVertexAttribArray i : next
  'glDisableClientState( GL_VERTEX_ARRAY )
  end method

  end class

  function PixelColor(float fr,fg,fb,fa,ft=-1) as dword
  =====================================================
  if ft>=0 then
    fa=ft 'impose alpha
  end if
  dword ir=fr*0xff, ig=fg*0xff, ib=fb*0xff, ia=fa*0xff
  return ir+(ig<<8)+(ib<<16)+(ia<<24)
  end function

